/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */

import "package:flutter/foundation.dart";
import "package:logger/logger.dart";

import "log.dart";
import "smart_management.dart";

/// GetInterface allows any auxiliary package to be merged into the "Get"
/// class through extensions
abstract class GetInterface {
  SmartManagement smartManagement = SmartManagement.full;
  bool isLogEnable = kDebugMode;
  LogWriterCallback log = defaultLogWriterCallback;
  Logger logger = Logger(
    printer: PrettyPrinter(
        methodCount: 1,
        errorMethodCount: 6,
        lineLength: 60,
        colors: true,
        printEmojis: true,
        printTime: true),
  );
}
