/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */

import "dart:developer" as developer;
import "dart:io";

import "package:flutter/cupertino.dart";

import "get_main.dart";

///VoidCallback from logs
typedef LogWriterCallback = void Function(
  String text, {
  bool isError,
  DateTime? time,
  Object? error,
  StackTrace? stackTrace,
});

/// default logger from GetX
void defaultLogWriterCallback(
  String value, {
  bool isError = false,
  DateTime? time,
  Object? error,
  StackTrace? stackTrace,
}) {
  if (Get.isLogEnable || isError) {
    // if (isError) {
    //   Get.logger.e(value, error: error, stackTrace: stackTrace, time: time);
    // } else {
    //   Get.logger.d(value);
    // }
    final DateTime now = DateTime.now();
    final String timestamp =
        "${now.hour}:${now.minute}:${now.second}.${now.millisecond}";
    if (Platform.isIOS) {
      debugPrint("[GX]|$timestamp|$value");
    }
    developer.log(value, name: "GX|$timestamp", time: DateTime.now());
  }
}
